<?php

// No direct access to this file
defined('_JEXEC') or die;

abstract class MELOHelper
{	
	public static function addSubmenu($vName = 'weblinks')
	{
		JHtmlSidebar::addEntry(JText::_('COM_MELO_SUBMENU_WLINKS'),'index.php?option=com_melo&view=wlinks',$vName == 'wlinks');
		JHtmlSidebar::addEntry(JText::_('COM_MELO_SUBMENU_CATEGORIES'),'index.php?option=com_categories&extension=com_melo',$vName == 'categories');
		
		if ($vName == 'categories')
		{
			JToolbarHelper::title(JText::sprintf('COM_CATEGORIES_CATEGORIES_TITLE', JText::_('com_melo')),'melo-categories');
		}
	}
	
	public static function getActions($categoryId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;
	
		if (empty($categoryId))
		{
			$assetName = 'com_melo';
			$level = 'component';
		}
		else
		{
			$assetName = 'com_melo.category.'.(int) $categoryId;
			$level = 'category';
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.delete', 'core.edit.state', 'core.deleterecords'
		);

		foreach ($actions as $action)
		{
			$result->set($action->name,	$user->authorise($action->name, $assetName));
		}
	
		return $result;
	}

	/**
	 * Adds Count Items for Category Manager.
	 *
	 * @param   stdClass[]  &$items  The banner category objects
	 *
	 * @return  stdClass[]
	 *
	 * @since   3.5
	 */
	public static function countItems(&$items)
	{
		$db = JFactory::getDbo();
		foreach ($items as $item)
		{
			$item->count_trashed = 0;
			$item->count_archived = 0;
			$item->count_unpublished = 0;
			$item->count_published = 0;
			$query = $db->getQuery(true);
			$query->select('state, count(*) AS count')
			      ->from($db->qn('#__melo_links'))
			      ->where('catid = ' . (int) $item->id)
			      ->group('state');
			$db->setQuery($query);
			$banners = $db->loadObjectList();
			foreach ($banners as $banner)
			{
				if ($banner->state == 1)
				{
					$item->count_published = $banner->count;
				}
				if ($banner->state == 0)
				{
					$item->count_unpublished = $banner->count;
				}
				if ($banner->state == 2)
				{
					$item->count_archived = $banner->count;
				}
				if ($banner->state == -2)
				{
					$item->count_trashed = $banner->count;
				}
			}
		}
		return $items;
	}
	
}
