<?php


// No direct access
defined('_JEXEC') or die('Restricted access');

use Joomla\CMS\Application\ApplicationHelper;
// import Joomla table library
jimport('joomla.database.table');

class MELOTableWlink extends JTable
{

	public function __construct(&$db)
	{
		$this->setColumnAlias('published','state');
		parent::__construct('#__melo_links', 'id', $db);
	}
	
	public function store($updateNulls = false)
	{
		$date	= JFactory::getDate();
		$user	= JFactory::getUser();
		if ($this->id)
		{
			// Existing item
			$this->modified		= $date->toSql();
			$this->modified_by	= $user->get('id');
		}
		else
		{
			// New weblink. A weblink created and created_by field can be set by the user,
			// so we don't touch either of these if they are set.
			if (!(int) $this->created)
			{
				$this->created = $date->toSql();
			}
			if (empty($this->created_by))
			{
				$this->created_by = $user->get('id');
			}
		}

		if (!$this->created) {
			$this->created = $date->toSql();
		}

		// Set publish_up to null date if not set
		if (!$this->publish_up)
		{
			$this->publish_up = $this->_db->getNullDate();
		}

		// Set publish_down to null date if not set
		if (!$this->publish_down)
		{
			$this->publish_down = $this->_db->getNullDate();
		}

		// Verify that the alias is unique
		$table = JTable::getInstance('WLink', 'MELOTable');

		if ($table->load(array('alias' => $this->alias, 'catid' => $this->catid)) && ($table->id != $this->id || $this->id == 0))
		{
			$this->setError(JText::_('COM_MELO_ERROR_UNIQUE_ALIAS'));
			return false;
		}

		$result = parent::store($updateNulls);
		return $result;
	}

	public function check()
	{
		if (JFilterInput::checkAttribute(array ('href', $this->url)))
		{
			$this->setError(JText::_('COM_MELO_WARNING_PROVIDE_VALID_URL'));
			return false;
		}

		// check for valid name
		if (trim($this->name) == '')
		{
			$this->setError(JText::_('COM_MELO_WARNING_PROVIDE_VALID_NAME'));
			return false;
		}

		// check for existing name
		$query = 'SELECT id FROM #__melo_links WHERE name = '.$this->_db->quote($this->name).' AND catid = '.(int) $this->catid;
		$this->_db->setQuery($query);

		$xid = (int) $this->_db->loadResult();
		if ($xid && $xid != (int) $this->id)
		{
			$this->setError(JText::_('COM_MELO_WARNING_SAME_NAME'));
			return false;
		}

		if (empty($this->alias))
		{
			$this->alias = $this->name;
		}
		$this->alias = ApplicationHelper::stringURLSafe($this->alias);
		if (trim(str_replace('-', '', $this->alias)) == '')
		{
			$this->alias = JFactory::getDate()->format("Y-m-d-H-i-s");
		}

		// Check the publish down date is not earlier than publish up.
		if ($this->publish_down > $this->_db->getNullDate() && $this->publish_down < $this->publish_up)
		{
			$this->setError(JText::_('JGLOBAL_START_PUBLISH_AFTER_FINISH'));
			return false;
		}

		return true;
	}
	
	public function hit($pk = null)
	{
		// If there is no hits field, just return true.
		if (!property_exists($this, 'hits'))
		{
			return true;
		}
	
		$k = $this->_tbl_key;
		$pk = (is_null($pk)) ? $this->$k : $pk;
	
		// If no primary key is given, return false.
		if ($pk === null)
		{
			return false;
		}
	
		// Check the row in by primary key.
		$query = $this->_db->getQuery(true)
		->update($this->_tbl)
		->set($this->_db->quoteName('hits') . ' = (' . $this->_db->quoteName('hits') . ' + 1)')
		->where($this->_tbl_key . ' = ' . $this->_db->quote($pk));
		$this->_db->setQuery($query);
		$this->_db->execute();
	
		// Set table values in the object.
		$this->hits++;
	
		return true;
	}
}